// Gavriel State 27jun97
// gav@magmacom.com

// This is JNIT #30.  It is a JNIT that patches GetNextEvent to call a GNE filter proc

#include <Types.h>
#include <Resources.h>
#include <Folders.h>
#include <Events.h>

#include <SetupA4.h>
#include <A4Stuff.h>
#include <LowMem.h>
#include <Traps.h>


typedef pascal Boolean (*GetNextEventProcPtr)(EventMask eventMask, EventRecord *theEvent);

GetNextEventProcPtr	gOldGetNextEvent;

pascal Boolean PatchGetNextEvent(EventMask eventMask, EventRecord *theEvent);


//---------------------------------------------------------------------------
// The GNE caller function
//---------------------------------------------------------------------------

// The jGNEFilterProc must be called with the EventRecord in A1 and the 
// Boolean in D0.  The boolean is also returned in D0.  This little piece of asm 
// calls the filterProc for us
Boolean CalljGNEFilter(GetNextEventFilterProcPtr theProc, EventRecord *theEvent, Boolean handleIt);

#pragma parameter __D0 CalljGNEFilter(__A0, __A1, __D0)
Boolean CalljGNEFilter(GetNextEventFilterProcPtr theProc, EventRecord *theEvent, Boolean handleIt) = {0x4e90};

//---------------------------------------------------------------------------
// The patch function
//---------------------------------------------------------------------------
pascal Boolean PatchGetNextEvent(EventMask eventMask, EventRecord *theEvent)
{
	Boolean	result;
	
	// Set up A4 globals
	EnterCallback();
	
	// Call the original routine
	result = (*gOldGetNextEvent)(eventMask, theEvent);

	GetNextEventFilterProcPtr theGNEFilter = (GetNextEventFilterProcPtr)LMGetGNEFilter();
		
	// Call the filter and determine if it handled the event
	result = CalljGNEFilter (theGNEFilter, theEvent, result);
	
	// Tear down A4 globals
	ExitCallback();
	
	return result;
}



//---------------------------------------------------------------------------
// The INIT main and patch installer.
//---------------------------------------------------------------------------
int main(void)
{
	Handle H;
	
	EnterCodeResource();	// Set up for globals	
	PrepareCallback();
	
	// Set up the patch - the INIT *must* be in the Sysheap
	H = GetResource('JNIT',30);
	if (H) 
	{
		// Detach and lock the patch
		DetachResource(H);
		HLock(H);
		HNoPurge(H);

		// Get the old address
		gOldGetNextEvent = (GetNextEventProcPtr)NGetTrapAddress(_GetNextEvent, ToolTrap);
		
		// Install the patch
		NSetTrapAddress((UniversalProcPtr)&PatchGetNextEvent, _GetNextEvent, ToolTrap);

	}
	
	ExitCodeResource();		// Shutdown use of globals (A4).
}