// Gavriel State 27jun97
// gav@magmacom.com

// This is JNIT #31.  It is a JNIT that loads all extensions in the JExtensions folder in your
// system folder into Jasik.

#include <Types.h>
#include <Resources.h>
#include <Folders.h>
#include "MoreFilesExtras.h"
#include "IterateDirectory.h"

typedef pascal void ( *INITFunction ) ( void );

pascal	void LoadJNIT (const CInfoPBRec * const cpbPtr,
						Boolean *quitFlag, void *yourDataPtr);

void main (void)
{

	short	foundVRefNum;
	long	foundDirID;
		
	OSErr err = ::FindFolder(kOnSystemDisk, kSystemFolderType, false, &foundVRefNum, &foundDirID);

	if (err == noErr)
	{
		// Get the JExtensions dir ID
		long	theDirID;
		Boolean	isDirectory;
		OSErr	err = ::GetDirectoryID(foundVRefNum, foundDirID, "\pJExtensions", &theDirID, &isDirectory);
		
		if (err == noErr)
		{
			// Set up the FSSpec
			FSSpec	jnitFolderSpec;
			jnitFolderSpec.vRefNum = foundVRefNum;
			jnitFolderSpec.parID = theDirID;
			jnitFolderSpec.name[0] = 0;
			
			OSErr iterErr = ::FSpIterateDirectory(&jnitFolderSpec, 1, LoadJNIT, &jnitFolderSpec);
		}
	}				
}

pascal	void LoadJNIT (const CInfoPBRec * const cpbPtr,
						Boolean *quitFlag, void *yourDataPtr)
{
	FSSpec	*rootSpec = (FSSpec *)yourDataPtr;
	
	// Check the file type to see if it's 'INIT' or CDEV'
	if ((cpbPtr->hFileInfo.ioFlFndrInfo.fdType == 'INIT') ||
		(cpbPtr->hFileInfo.ioFlFndrInfo.fdType == 'cdev'))
	{
		// FSSpec comes from the passed parent and the filename
		FSSpec		initSpec;
		initSpec.vRefNum = rootSpec->vRefNum;
		initSpec.parID = rootSpec->parID;
		::BlockMoveData(cpbPtr->hFileInfo.ioNamePtr, &initSpec.name, cpbPtr->hFileInfo.ioNamePtr[0]+1);
				
		short curRes = ::CurResFile();
		// Open the resource fork of the file, load and lock the INIT, and run
		short resFileID = FSpOpenResFile(&initSpec, fsCurPerm);

		if (resFileID != -1)
		{
			// It should already be at the top of the Map, but
			// just in case....
			::UseResFile(resFileID);
			
			// Go through all the INITs in the file.		
			int numINITs = ::Count1Resources('INIT');
			
			for (int count = 1; count <= numINITs; count++)
			{
				Handle theINITHandle = ::Get1IndResource('INIT', count);
				
				if (theINITHandle)
				{
					::HLock(theINITHandle);
					INITFunction theJNITPtr = reinterpret_cast<INITFunction>(*theINITHandle);
					(*theJNITPtr)();		
				}
			}	
			
			// Close the res file
			::CloseResFile (resFileID);
		}
		
		::UseResFile (curRes);
	}
	
	// Keep going until there are no more files to look through.
	*quitFlag = false;
}						

