/*------------------------------------------------------------------------------
#
#	NewsTicker, my Hack for 1997
#
#	BeachBall.h	-	Just a simple class to spin the beach ball while waiting
#
------------------------------------------------------------------------------*/

#ifndef		BEACHBALL_H
#define		BEACHBALL_H



#define kFirstBeachBallCursorID				180
#define kNumBeachBallCursors					4

	
class BeachBall 
	{
	public:
		BeachBall(short firstCursorID = kFirstBeachBallCursorID,
				short numCursors = kNumBeachBallCursors,
				short resFileRefNum = CurResFile());		
			// The firstCursorID must be a positive integer.	
		~BeachBall();
		void Idle();	
	
	private:
		short				mResFileRefNum;
		short				mFirstBeachBallCursorID;
		short				mNumBeachBallCursors;
		short 				mBeachBallIntervalInTicks;
		short				mCurrentBeachBallCursorID;
		unsigned long		mTicksAtPrevBeachBall;
		
		BeachBall(const BeachBall&);
			// Unimplemented private copy constructor so class cannot be copied.
			// We are short circuiting the default copy constructor mechanism here.
			// The compiler will warn you if you attempt to copy this class.
		operator = (const BeachBall&);		
			// Unimplemented private assignment operator so class cannot be assigned.
			// We are short circuiting the default assignment operator mechanism here.
			// The compiler will warn you if you attempt to assign this class.
	};
	
	
	
#endif		//		BEACHBALL_H




