/**********************************************************************************
	FILE: Idler.cp
	Description: A class whose derivative can do things like check for command
		period, spin a beach ball, etc.

	1996, CE Software, Inc.  All rights reserved.
	P.O. Box 65580
	West Des Moines, Iowa 50265 U.S.A.

***********************************************************************************/

#include "Idler.h"

Idler::Idler (void)
{
	mlPeriod = -1;
}

Boolean Idler::PeriodHasExpired (void)
{
	return (mlPeriod == -1 || mulNextPeriod <= TickCount ());
}

void Idler::YieldTime (void)
{
	if (PeriodHasExpired ())
	{
		mulNextPeriod = TickCount () + mlPeriod;
		YieldAction ();
	}
}

void Idler::SetPeriod (long lPeriod)
{
	mlPeriod = lPeriod;
	mulNextPeriod = TickCount () + lPeriod;
}
