// CWPWindow.h

#ifndef CWPWindow_h
#define CWPWindow_h

#ifndef Window_h
#include "Window.h"
#endif
#ifndef StringView_h
#include "StringView.h"
#endif
#ifndef PaneColumn_h
#include "PaneColumn.h"
#endif
#ifndef CWWatcher_h
#include "CWWatcher.h"
#endif
#ifndef Ear_h
#include "Ear.h"
#endif
#ifndef Progress_h
#include "Progress.h"
#endif
#ifndef ProgressView_h
#include "ProgressView.h"
#endif
#ifndef SolidFrame_h
#include "SolidFrame.h"
#endif
#ifndef NumeralView_h
#include "NumeralView.h"
#endif
#ifndef PaneRow_h
#include "PaneRow.h"
#endif
#ifndef VerticalSpacer_h
#include "VerticalSpacer.h"
#endif

class CWPWindow: public Window
  {
	private:
		Progress progress;
		
		StringView remainingText;
		NumeralView remainingNumber;
		
		VerticalSpacer space1;
		
		StringView compiling;
		
		VerticalSpacer space2;
		
		ProgressView bar;
		
		SolidFrame progressFrame;
		
		PaneRow<2> remainingRow;
		PaneColumn<5> column;
		
		SolidFrame margin;
		
		CWWatcher watcher;
		Ear<CWPWindow> ear;
		
		void UpdateProgress();
		
	public:
		CWPWindow( const WindowInitializer& );
		~CWPWindow();
  };

#endif
