// FileStatistics.h

#ifndef FileStatistics_h
#define FileStatistics_h

#ifndef Str_h
#include "Str.h"
#endif
#ifndef RedBlackLink_h
#include "RedBlackLink.h"
#endif

class FileStatistics
  {
	friend class CompileStatistics;
	
 	private:
		const String31 name;
		uint32 lines;
		RedBlackLink< ConstPString, FileStatistics > link;
	
	public:
		FileStatistics( ConstPString name, uint32 lines );
		~FileStatistics();
		
		uint32 Lines() const			{ return lines; }
		void SetLines( uint32 n )	{ lines = n; }
		
		ConstPString Name() const	{ return name; }
  };

#endif
