// Activator.h

#ifndef Activator_h
#define Activator_h

#ifndef Enableable_h
#include "Enableable.h"
#endif
#ifndef ListLink_h
#include "ListLink.h"
#endif
#ifndef ContextUser_h
#include "ContextUser.h"
#endif

class Focus;

class Activator: public ContextUser,
					  public Enableable
  {
	friend class Focus;
	
	private:
		bool active;
		bool focusActive;
		
		ListLink< Activator > link;
	
		void FocusActivated();
		void FocusDeactivated();
	
	protected:
		virtual void Activate() 	{}
		virtual void Deactivate() 	{}

		virtual void BeEnabled();
		virtual void BeDisabled();
		
	public:
		Activator( Focus& );
		~Activator();
		
		bool Active() const		{ return active; }
  };

#endif
