// Focus.h

#ifndef Focus_h
#define Focus_h

#ifndef ListOf_h
#include "ListOf.h"
#endif

class Focus
  {
	friend class RootFocus;
	friend class Activator;
	
	private:
		ListOf< Activator > activators;
		Focus *const parent;
		Focus *favoredChild;
		uint32 children;
		bool active;
		
		Focus();
		
		void Activate();
		void Deactivate();
		
		// not implemented:
			Focus( const Focus& );
			void operator=( const Focus& );
		
	public:
		Focus( Below, Focus& parent );
		~Focus();
		
		Focus *Parent() const				{ return parent; }
		
		bool Active() const					{ return active; }
		
		Focus *FavoredChild() const		{ return favoredChild; }
		void FavorChild( Focus& );
		void FavorNoChild();
		
		void BeFavored();
		void BeDisfavored();
  };

#endif
