// ConstData.h

#ifndef ConstData_h
#define ConstData_h

#ifndef ConstArrayOf_h
#include "ConstArrayOf.h"
#endif

class ConstData: public ConstArrayOf<uint8>
  {
	public:
		ConstData()		{}
		
		ConstData( ConstArrayOf<uint8> array )
		  : ConstArrayOf<uint8>( array )
		  {}
		
		ConstData( const void *theStart, uint32 theLength )
		  : ConstArrayOf<uint8>( static_cast<const uint8 *>(theStart), theLength )
		  {}
		
		bool operator==( const ConstData& ) const;
		bool operator<( const ConstData& ) const;
		bool operator<=( const ConstData& ) const;
		
		bool operator!=( const ConstData& b ) const	{ return !( *this == b ); }
		bool operator>( const ConstData& b ) const	{ return !( *this <= b ); }
		bool operator>=( const ConstData& b ) const	{ return !( *this < b ); }
		
		bool StartsWith( ConstData ) const;
		bool EndsWith( ConstData ) const;
  };

int32 Compare( ConstData a, ConstData b );

#endif
