// ResumeEvent.cp

#ifndef ResumeEvent_h
#include "ResumeEvent.h"
#endif
#ifndef RootFocus_h
#include "RootFocus.h"
#endif
#ifndef UserState_h
#include "UserState.h"
#endif

ResumeEvent::ResumeEvent( const EventRecord& event )
  : Event( event ),
	 convertClipboard( (event.message & convertClipboardFlag) != 0 )
  {
	Assert( event.what == osEvt );
	Assert( Byte3( event.message ) == suspendResumeMessage );
	Assert( (event.message & resumeFlag) != 0 );
  }

void ResumeEvent::Respond() const
  {
	RootFocus::Activate();
	UserState::The().Announce();
  }
