// DiskInsertionEvent.cp

#ifndef DiskInsertionEvent_h
#include "DiskInsertionEvent.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif
#ifndef OSError_h
#include "OSError.h"
#endif
#ifndef PointObject_h
#include "PointObject.h"
#endif
#ifndef DiskInsertionReceiver_h
#include "DiskInsertionReceiver.h"
#endif

DiskInsertionEvent::DiskInsertionEvent( const EventRecord& event )
  : UserEvent( event ),
	 drive( Word0( event.message ) ),
	 mountError( Word1( event.message ) )
  {
	Assert( event.what == diskEvt );
  }

void DiskInsertionEvent::Respond() const
  {
	OSErr initializationError = noErr;
	
	if ( mountError != noErr )
	  {
		DILoad();
		initializationError = DIBadMount( PointObject( 120, 120 ),
													 ( uint32( mountError ) << 16 ) | uint32( drive ) );
		DIUnload();
	  }
	
	DiskInsertionReceiver::Send( *this, initializationError );
  }
