// FileType.h

#ifndef FileType_h
#define FileType_h

#ifndef Integers_h
#include "Integers.h"
#endif

class FileType
  {
	private:
		uint32 type;
	
		FileType( uint32 value )
		  : type( value )
		  {}
		
	public:
		static FileType Make( uint32 value )	{ return value; }
	
		uint32 Type() const							{ return type; }
		
		bool operator==( FileType f ) const		{ return type == f.type; }
		bool operator!=( FileType f ) const		{ return type != f.type; }
		
		static FileType Application()				{ return 'APPL'; }
		static FileType Text()						{ return 'TEXT'; }
		static FileType ReadOnlyText()			{ return 'ttro'; }
		static FileType Picture()					{ return 'PICT'; }

		static FileType FontResource()			{ return 'ffil'; }
		static FileType KeyboardResource()		{ return 'kfil'; }
		static FileType ScriptResource()			{ return 'ifil'; }
		static FileType SoundResource()			{ return 'sfil'; }
		static FileType TrueTypeFontResource()	{ return 'tfil'; }
  };

#endif
