// TypingMessage.cp

#ifndef TypingMessage_h
#include "TypingMessage.h"
#endif
#ifndef Commander_h
#include "Commander.h"
#endif
#ifndef Typing_h
#include "Typing.h"
#endif
#ifndef Key_h
#include "Key.h"
#endif

TypingMessage::TypingMessage( Key theKey )
  {
	Assert( theKey.ForTyping() );
	buffer += theKey.Character();
  }

bool TypingMessage::CanAppend() const
  {
	return buffer.Length() < buffer.StorageLength();
  }

bool TypingMessage::Append( Key key )
  {
	if ( key.Special() )
		return false;
	
	buffer += key.Character();
	return true;
  }

void TypingMessage::Send() const
  {
	if ( !Commander<Typing>::Null() )
		Commander<Typing>()->Type( buffer );
  }
