// FiniteQueue.h

#ifndef FiniteQueue_h
#define FiniteQueue_h

#ifndef FiniteQueueBase_h
#include "FiniteQueueBase.h"
#endif
#ifndef AlignedBlock_h
#include "AlignedBlock.h"
#endif
#ifndef Assert_h
#include "Assert.h"
#endif

template < class Element, uint32 size >
class FiniteQueue: public FiniteQueueBase
  {
	private:
		AlignedBlock< size * sizeof( Element ) > space;
	
	public:
		FiniteQueue()
		  : FiniteQueueBase( space, size, sizeof( Element ) )
		  {}
		
		void Delete( Element *p )
		  {
			Assert( p != 0 );
			p->~Element();
			Release( p );
		  }	
  };

#endif
