// SingleAllocatorBase.h

#ifndef SingleAllocatorBase_h
#define SingleAllocatorBase_h

#ifndef Data_h
#include "Data.h"
#endif

class SingleAllocatorBase
  {
	private:
		const Data space;
		bool full;
		
	public:
		SingleAllocatorBase( Data );
		
		bool Full() const		{ return full; }
		bool Empty() const	{ return !full; }
		
		void *Allocate( uint32 size )
		  {
			Assert( size <= space.Length() );
			Assert( !full );
			full = true;
			return space.Start();
		  }
		
		void Release( void *p )
		  {
			Assert( full );
			Assert( p == space.Start() );
			full = false;
		  }
  };

inline void *operator new( uint32 size, SingleAllocatorBase& pool )
  { return pool.Allocate( size ); }

#endif
