// ArrangementLoop.h

#ifndef ArrangementLoop_h
#define ArrangementLoop_h

#ifndef ArrangementBase_h
#include "ArrangementBase.h"
#endif

class ArrangementLoop
  {
	private:
		ArrangementBase& arrangement;
		uint32 index;
	
	public:
		ArrangementLoop( ArrangementBase& );
		
		bool Finished() const		{ return index >= arrangement.PaneCount(); }
		bool Unfinished() const		{ return index < arrangement.PaneCount(); }
		
		void operator++();
		void operator++(int)			{ operator++(); }
		
		ArrangedPane& operator*() const		{ return arrangement[index]; }
		ArrangedPane *operator->() const		{ return &arrangement[index]; }
  };

#endif
