// Frame.h

#ifndef Frame_h
#define Frame_h

#ifndef View_h
#include "View.h"
#endif
#ifndef ArrangedPane_h
#include "ArrangedPane.h"
#endif

class Frame: public View
  {
	private:
		ArrangedPane interior;
		const Rectangle thickness;

	protected:
		virtual void GainMapping();
		virtual void LoseMapping();
		virtual void ChangeBounds( Rectangle oldBounds );
	
	public:
		Frame( Rectangle theThickness )
		  : interior( *this ),
			 thickness( theThickness )
		  {}
		
		const Pane& Interior() const			{ return interior; }
		Pane& Interior()							{ return interior; }
		
		virtual void Draw( const ViewMap& ) const;
		
		virtual void DrawBorder( const ViewMap&, Rectangle interior ) const = 0;
		
		virtual uint16 MinimumWidth() const;
		virtual uint16 MinimumHeight() const;
		
		virtual uint16 MaximumWidth() const;
		virtual uint16 MaximumHeight() const;
		
		virtual uint16 ReasonableWidth() const;
		virtual uint16 ReasonableHeight() const;
		
		virtual uint16 BestWidth() const;
		virtual uint16 BestHeight() const;
		
		virtual uint16 BestWidth( uint16 bound ) const;
		virtual uint16 BestHeight( uint16 bound ) const;
  };

#endif
