// NumeralView.cp

#ifndef NumeralView_h
#include "NumeralView.h"
#endif

NumeralView::NumeralView( ::Face face )
  : StringView( face ),
	 digits( 11 )
  {
  }

void NumeralView::SetNumber( int32 n )
  {
	String255 numeral;
	NumToString( n, numeral );
	SetString( numeral );
  }

uint16 NumeralView::MinimumWidth() const
  {
	String255 string;
	string.SetLength( digits );
	for ( uint32 i = 0; i < digits; i++ )
		string[i] = '0';
	return WidthOf( string );
  }

uint16 NumeralView::BestWidth() const
  {
	return MinimumWidth();
  }
