// PaneRowBase.h

#ifndef PaneRowBase_h
#define PaneRowBase_h

#ifndef ArrangementBase_h
#include "ArrangementBase.h"
#endif

class PaneRowBase: public ArrangementBase
  {
	protected:
		virtual void Arrange( Rectangle );
	
	public:
		PaneRowBase( ArrangedPane *thePanes,
						 uint32 paneCount )
		  : ArrangementBase( thePanes, paneCount )
		  {}

		virtual uint16 MinimumWidth() const;
		virtual uint16 MinimumHeight() const;
		
		virtual uint16 MaximumWidth() const;
		virtual uint16 MaximumHeight() const;

		virtual uint16 ReasonableWidth() const;
		virtual uint16 ReasonableHeight() const;
		
		virtual uint16 BestWidth() const;
		virtual uint16 BestWidth( uint16 bound ) const;
		
		virtual uint16 BestHeight() const;
		virtual uint16 BestHeight( uint16 bound ) const;
  };

#endif
