// ListView.h

#ifndef ListView_h
#define ListView_h

#ifndef View_h
#include "View.h"
#endif

class ViewCell;

class ListView: public View
  {
	private:
		uint32 cellHeight;
		uint32 cellCount;
		
		uint32 PixelToCell( uint32 p ) const 	{ return p / cellHeight; }
		
		Rectangle CellArea( const ViewMap&, uint32 cell ) const;
		Rectangle CellArea( const ViewMap&, Range<uint32> cells ) const;
		Rectangle UnusedArea( const ViewMap& ) const;
		
	protected:
		virtual const ViewCell& operator[]( uint32 ) const = 0;
		virtual ViewCell& operator[]( uint32 ) = 0;
		
		void SetCellHeight( uint32 );
		
		void AddedCells( Range<uint32> );
		void RemovedCells( Range<uint32 > );
		
	public:
		ListView();
		
		virtual void Draw( const ViewMap& ) const;
		
		void Update( uint32 ) const;
		void Redraw( uint32 ) const;
		void Invalidate( uint32 ) const;
		
		void Update( Range<uint32> ) const;
		void Redraw( Range<uint32> ) const;
		void Invalidate( Range<uint32> ) const;
  };

#endif
