// ProgressWindow.cp

#ifndef ProgressWindow_h
#include "ProgressWindow.h"
#endif
#ifndef ContextMaintainer_h
#include "ContextMaintainer.h"
#endif
#ifndef WindowDefinition_h
#include "WindowDefinition.h"
#endif

ProgressWindow *NewProgressWindow( const WindowInitializer& initializer,
											  const Progress& progress )
  {
	ContextMaintainer cm( 0 );
	return new ProgressWindow( initializer, progress );
  }

ProgressWindow::ProgressWindow( const WindowInitializer& initializer,
										  const Progress& progress )
  : Window( WindowDefinition::Document() ),
	 root( Focus() ),
	 bar( progress ),
	 right( Focus() ),
	 bottom( Focus() )
  {
	root.Main().SetView( bar );
	root.Bottom().SetView( bottom );
	root.Right().SetView( right );
	
	RootPane().SetView( root );
	
	Initialize( initializer );
  }
