// StrangeWindow.cp

#ifndef StrangeWindow_h
#include "StrangeWindow.h"
#endif
#ifndef WindowUpdater_h
#include "WindowUpdater.h"
#endif
#ifndef MouseDownEvent_h
#include "MouseDownEvent.h"
#endif
#ifndef GrayRegion_h
#include "GrayRegion.h"
#endif

void StrangeWindow::Update()
  {
	WindowUpdater updater( window );
  }

void StrangeWindow::Activate()
  {
  }

void StrangeWindow::Deactivate()
  {
  }

void StrangeWindow::ClickContent( const MouseDownEvent& )
  {
	if ( window != FrontWindow() )
		SelectWindow( window );
  }

void StrangeWindow::ClickDrag( const MouseDownEvent& click )
  {
	if ( window != FrontWindow() && !click.Command() )
		SelectWindow( window );
	
	DragWindow( window, click.Where(), &GrayRegion::The().Bounds() );
  }

void StrangeWindow::ClickClose( const MouseDownEvent& click )
  {
	Assert( window == FrontWindow() );
	
	if ( TrackGoAway( window, click.Where() ) )
		HideWindow( window );
  }

void StrangeWindow::ClickZoomIn( const MouseDownEvent& click )
  {
	Assert( window == FrontWindow() );

	if ( TrackBox( window, click.Where(), inZoomIn ) )
		ZoomWindow( window, inZoomIn, true );
  }

void StrangeWindow::ClickZoomOut( const MouseDownEvent& click )
  {
	Assert( window == FrontWindow() );

	if ( TrackBox( window, click.Where(), inZoomOut ) )
		ZoomWindow( window, inZoomOut, true );
  }

void StrangeWindow::ClickGrow( const MouseDownEvent& click )
  {
	Assert( window == FrontWindow() );

	static const Rect limits = { 64, 64, maxint16, maxint16 };
	
	int32 result = GrowWindow( window, click.Where(), &limits );
	
	if ( result != 0 )
		SizeWindow( window, Word0( result ), Word1( result ), true );
  }
